; pager/theme.jl
;; stuff below is very poor

(defgroup pager-frame "Pager theme" :group appearance)

(defcustom pager:inactive-menu "rightstripe.png"
  "inactive shade-button."
  :group (appearance pager-frame)
  :type file-name)
  ;:after-set (lambda () (reframe-all)))

(defcustom pager:inactive-hover "rightstripeh.png"
  "inactive shade-button-highlighted"
  :group (appearance pager-frame)
  :type file-name)

;(defcustom pager:inactive-click "rightstripe.png"
;  "inactive shade-button-clicked"
;  :group (appearance pager-frame)
;  :type file-name)

(defcustom pager:active-menu "rightstripeh.png"
  "active shade-button."
  :group (appearance pager-frame)
  :type file-name)
  ;:after-set (lambda () (reframe-all)))

;;
(defcustom pager:inactive-shade "rightstripe.png"
  "inactive shaded-button"
  :group (appearance pager-frame)
  :type file-name)
  

(defcustom pager:inactive-shover "rightstripeh.png"
  "inactive shaded-button-clicked"
  :group (appearance pager-frame)
  :type file-name)
  
;;;;;;;;;;;;;;;;;;;;;;
(defcustom pager:normal-color nil
  "Accent color for focused windows (if unset uses the GTK+ selection color)."
  :type (optional color)
  :group (appearance pager-frame)
  :user-level novice
  :after-set (lambda () (color-changed)))
;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;
;;define shit;;
;;;;;;;;;;;;;;;

(define menu-image `((inactive . ,(make-image pager:inactive-menu))
		    (inactive-highlighted . ,(make-image pager:inactive-hover))
                    ;(inactive-clicked . ,(make-image pager:inactive-click))
                    (clicked . ,(make-image pager:active-menu))))

(define shade-image `((inactive . ,(make-image pager:inactive-shade))
		     (inactive-clicked . ,(make-image pager:inactive-shover))))
                   
;;;;;;;;;;;;;;;;;;    

(define title-image (make-image "top.png"))
(define top-left-image (make-image "cor.png"))
(define right-image (make-image "bit.png"))
(define top-right-image (make-image "tpcor.png"))
(define bottom-image (list (make-image "b1.png")
	                (make-image "b1.png")))
(define top-image (make-image "line.png")) 
(define right-bit (make-image "horbline.png")) 

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(define (rebuild);

;;you suck

(when (and (or (not pager:inactive-menu)
		 (not pager:active-menu))  
(lambda () (rebuild-frames-with-style 'pager))))
  (rebuild-frames-with-style 'pager))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;       

(define frame 

`(((background . ,top-left-image)
         (top-edge . -2)
         (left-edge . -20)
         (class . title))
        
((background . ,title-image)
         
         (x-justify . left)
         (y-justify . center)
         (left-edge . -19)
         (right-edge . -3)
         (top-edge . -2)
         ;(height . 20)
         (class . title))
        
((background . ,top-right-image)
         (right-edge . -3)
         (top-edge . -2)
         (class . title))
                
((background . ,right-image)
         (right-edge . -3)
         (top-edge . 0)
         (bottom-edge . -2)
         (class . right-border))
     
((background . ,bottom-image)
         (left-edge . 0)
         (right-edge . 0)
         (bottom-edge . -2)
         (class . bottom-border))
        
((background . ,menu-image)
         (left-edge . -20)
         (top-edge . 0)
         (bottom-edge . -2)
         (class . title))

((background . ,top-image)
         (left-edge . 0)
         (top-edge . 0)
         (right-edge . 0)
	 (class . title))      

((background . ,right-bit)
         (left-edge . 0)
         (top-edge . 0)
         (bottom-edge . 0)
	 (class . left-border))      
))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;dubious stuff;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

  
(define shaped-frame 

`(((background . ,top-left-image)
         (top-edge . -2)
         (right-edge . 16)
         (class . top-left-corner))
        
((background . ,title-image)
         
         (right-edge . -5)
         (top-edge . -2)
         (width . 21)
         (class . title))
        
((background . ,top-right-image)
         (right-edge . -6)
         (top-edge . -2)
         (class . title))
                
((background . ,right-image)
         (right-edge . -6)
         (top-edge . 0)
         (bottom-edge . -2)
         (class . right-border))
        
        
((background . ,bottom-image)
         ;(left-edge . 0)
         (right-edge . -3)
         (bottom-edge . -2)
         (width . 20)
          (class . bottom-border))
        
((background . ,shade-image)
         (right-edge . -3)
         (top-edge . 0)
         (bottom-edge . -2)
	 (cursor . left_ptr)
         (class . shade-button))

))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(define (foreground-color)
  (if (colorp pager:normal-color)
      pager:normal-color
    (initialize-gtkrc)
    (if (colorp (nth 3 gtkrc-background))
	(nth 3 gtkrc-background)
      (get-color "steelblue"))))

;;

(define (recolor-all)
  
  (let ((recolorer (make-image-recolorer (foreground-color)
					 #:zero-channel blue-channel
					 #:index-channel green-channel))))
    
(mapc (lambda (x) (mapc recolorer (cdr x)))
	  (list bottom-image
		menu-image
                title-image  
                top-left-image 
                right-image   
                shade-image 
                top-right-image 
                top-image  
                right-bit))
    (mapc (lambda (x)
	    (recolorer (cdr x))) menu-button)))
;;;;;

(define (rebuild-all)
  (rebuild-frames-with-style 'pager))

(define (reframe-all)
  (reframe-windows-with-style 'pager))

(define (color-changed)
  (recolor-all)
  (reframe-all))

;(define (get-frame w type)
;  (case type
;    ((default)
;     (make-frame w normal-frame))
;    ((shaped)
;     (make-frame w shaped-frame ))))
    
(define initialize-gtkrc
  (let ((done nil))
    (lambda ()
      (unless done
	(require 'gtkrc)
	;; recolour everything when the GTK theme changes
	(gtkrc-call-after-changed color-changed)
	(setq done t)))))

;; setup the initial colours
(recolor-all)

;; register the theme
;(add-frame-style 'pager get-frame)
(add-frame-style 'pager
		   (lambda (w type)
		     (case type
		       ((default) frame)
		       ((shaped) shaped-frame)
		       )))
;; recalibrate frames when the window-name changes
(call-after-property-changed 'WM_NAME rebuild-all)
